# Flutter Cookbook

<a href="https://www.packtpub.com/product/google-flutter-2-cookbook/9781838823382?utm_source=github&utm_medium=repository&utm_campaign=9781838823382"><img src="https://github.com/PacktPublishing/Flutter-Cookbook/blob/master/Cover%20image.png" alt="Flutter Cookbook" height="256px" align="right"></a>

This is the code repository for [Flutter Cookbook](https://www.packtpub.com/product/google-flutter-2-cookbook/9781838823382?utm_source=github&utm_medium=repository&utm_campaign=9781838823382), published by Packt.

**Over 100 proven techniques and solutions for app development with Flutter 2.2 and Dart**

## What is this book about?
Flutter is an open-source framework for building mobile, web, and desktop apps using the Dart language. With this recipe-based guide, which focuses on robust app design and core principles, you’ll learn how to solve cross-platform development issues in a practical way.

This book covers the following exciting features: 
* Build native iOS and Android apps from a single codebase
* Discover how to develop and think like a Dart programmer
* Find simple solutions to complex problems by applying the principle of composition over inheritance
* Create reusable architecture that can be applied to any type of app
* Quickly debug and solve problems before users can see them

If you feel this book is for you, get your [copy](https://www.amazon.com/dp/1838823387) today!

<a href="https://www.packtpub.com/?utm_source=github&utm_medium=banner&utm_campaign=GitHubBanner"><img src="https://raw.githubusercontent.com/PacktPublishing/GitHub/master/GitHub.png" 
alt="https://www.packtpub.com/" border="5" /></a>


## Instructions and Navigations
All of the code is organized into folders. For example, Chapter02.

The code will look like the following:
```
void variablePlayground() {
basicTypes();
untypedVariables();
typeInterpolation();
immutableVariables();
}
```

**Following is what you need for this book:**

This app development book is for beginner to intermediate-level developers who want to become mobile developers. Basic knowledge of modern programming languages such as JavaScript, Swift, Kotlin, Java, Objective-C, or C# will help you to understand the concepts covered in the book more easily.

With the following software and hardware list you can run all code files present in the book (Chapter 1-15).

### Software and Hardware List

| Chapter  | Software required                                     | OS required                                             |
| -------- | ------------------------------------------------------| --------------------------------------------------------|
| 1-15     | Visual Studio Code, Android Studio, or IntelliJ Ide   | Windows, Mac OS X, and Linux                            |
| 1-15     | Flutter SDK                                           | Windows, Mac OS X, and Linux                            |
| 1-15     | An emulator/simulator or an iOS or Android device     | Windows, macOS, or Linux (macOS is needed only for iOS) |

In order to create apps for iOS, you will need a Mac.

## Errata
* Page 66, Section: How to do it... Step 3(code snippet line 3): **final MapString, int ages = { ...** _should be_ **final Map ages = { ...**
* Page 133, top line of text on the page : **5. Fill in the Flexible section. Don't forget to hot reload while writing the code:** _should be_ **5. Fill in the _buildFlexible method. Don't forget to hot reload while writing the code:**
* Page 168, last code line of 2nd point : **State createState() => StopWatchState();** _should be_ **State createState() => _StopWatchState(); // This needs to have an underscore in order to be treated as private.**
* Page 168, 1st code line of 3rd point : **class StopWatchState extends State<StopWatch> {** _should be_ **class _StopWatchState extends State<StopWatch> {**

<hr>

We also provide a PDF file that has color images of the screenshots/diagrams used in this book. [Click here to download it](https://static.packt-cdn.com/downloads/9781838823382_ColorImages.pdf).


## Get to Know the Authors
**Simone Alessandria**
wrote his first program when he was 12. It was a text-based fantasy game for the Commodore 64. Now, he is a trainer (MCT), author, speaker, passionate software architect, and always a proud coder. He is the founder and owner of Softwarehouse.it. His mission is to help developers achieve more through training and mentoring. He has authored several books on Flutter, including Flutter Projects, published by Packt, and web courses on Pluralsight and Udemy.

**Brian's**
career had him working on video games, eCommerce, productivity, finance, and travel apps. After spending years working as an iOS and Android developer, he sees Flutter as the next big pillar for mobile.


## Other books by the author
* [Flutter Projects](https://www.packtpub.com/product/flutter-projects/9781838647773?utm_source=github&utm_medium=repository&utm_campaign=9781838647773)



